/***************************************************************************
*
*                  NE PAS MODIFIER CETTE SECTION
*
**************************************************************************/
import java.awt.*;
import Listes.*;

public class Expresso extends FenetreTortue
{

/***************************************************************************
*
*                      SECTION MODIFIABLE
*
**************************************************************************/



/********************** Parametres de l'interface ************************/

    public static int baseFenetre = 780; // Largeur de la fenetre
    public static int hauteurFenetre = 560; // Hauteur de la fenetre
    public static String titreFenetre = "Les Coniques"; // Titre de la fen?tre
    // Le texte
    public static boolean zoneTexte = false; // Indique si on desire ou non une zone de texte
    // Les boutons
    public static String[] nomsBoutonsLigne1 = {};//"Ellipse", "Hyperbole horizontale", "Hyperbole verticale","Parabole horizontale","Parabole verticale"}; // Noms des boutons de la ligne 1
    public static String[] nomsBoutonsLigne2 = {};//"Quitter"}; // Noms des boutons de la ligne 2
    // Les menus
    public static String[] s_nomsMenus1 = {"Coniques","Ellipse","Hyperbole horizontale","Hyperbole verticale","Parabole horizontale","Parabole verticale"}; // Exemple: private static String[] nomsMenus1 = {"nomMenu", "nomItem_1", ...};
    public static String[] c_nomsMenus2 = {"Quitter","Quitter"}; // Laissez vide si vous ne desirez pas de menu
    public static String[] c_nomsMenus3 = {"Les auteures"," Noms des auteures"};
    public static String[] nomsMenus4 = {};
    public static String[] nomsMenus5 = {};
    public static String[] nomsMenus6 = {};
    public static String[] nomsMenus7 = {};
    public static String[] nomsMenus8 = {};

    public static void ajoutDeGlissieres(){
        ajouterGlissiereLigne1("Rayon", 0,7,5,0);
    }

/****************** Initialisation *********************************/

double centreX=0, centreY=0;
double [] sommetX = new double [7];
double [] sommetY = new double [7];

double h= 0;
double k= 0;
double a= 100;
double b= 50;

int ConiqueChoisie=0;
int pointDeplace=0;


public void initialisation(){



    placerPointsEllipse();

    DessinerConiques();  // dessine conique en ouvrant la fenetre
        // Placer ici les actions a realiser a l'ouverture
}

/****************** Placer vos procedures ici ****************************/



public void DessinerConiques(){

videTexte();
videGraphique();
if (ConiqueChoisie==0)  {DessinerEllipse();}
if (ConiqueChoisie==1)  {DessinerHyperboleHoriz();}
if (ConiqueChoisie==2)  {DessinerHyperboleVert();}
if (ConiqueChoisie==3)  {DessinerParaboleHoriz();}
if (ConiqueChoisie==4)  {DessinerParaboleVert();}
DessinerAxesDuPlan();

}

/***********************************PROCDURES POUR l'ELLIPSE*****************************************/

public void placerPointsEllipse() {
    centreX = h;
    centreY = k;

    sommetX[0] = a+h;
    sommetY[0] = k;

    sommetX [1] = h;
    sommetY [1] = k+b;

    sommetX [2] = h-a;
    sommetY [2] = k;

    sommetX [3] = h;
    sommetY [3] = k-b;
}

public void DessinerSommetsEllipse(){
   double rayondisque= valeurGlissiere(1);
   couleurRemplissage(noir);
   disque(centreX,centreY,rayondisque);
   disque(sommetX[0],sommetY[0],rayondisque);
   disque(sommetX[1],sommetY[1],rayondisque);
   disque(sommetX[2],sommetY[2],rayondisque);
   disque(sommetX[3],sommetY[3],rayondisque);


}

public void DessinerFoyersEllipse(){

    double rayondisque= valeurGlissiere(1);
    couleurRemplissage(bleu);

    if(abs(a)>abs(b)){
      disque (racine(a*a-b*b)+h, k, rayondisque);
      disque (-racine(a*a-b*b)+h, k, rayondisque);
    }
    if(abs(b)>abs(a)){
    disque (h,racine(b*b-a*a)+k, rayondisque);
    disque (h,-racine(b*b-a*a)+k, rayondisque);
    }
}


public void ContourEllipse(){

    double coordy ;

    double point1x= h-abs(a);
    double point1y= k ;



    for (double coordx = (h-abs(a)) ; coordx <= (h+abs(a)) ; coordx = 
coordx+1){
        double bcarre= b*b ;
        coordy = racine((bcarre-((coordx-h)*(coordx-h))/(a*a)*(bcarre)))+k;

        segment ( point1x, point1y, coordx , coordy);
        point1x=coordx ;
        point1y= coordy;
    }
    point1x = h- abs(a);   // Empeche de faire segment entre h-a et h+a
    point1y= k;


    for (double coordx = (h-abs(a)) ; coordx <= (h+abs(a)) ; coordx = coordx+1){
        double bcarre= b*b ;
        coordy = -racine((bcarre-((coordx-h)*(coordx-h))/(a*a)*(bcarre)))+k;

        segment ( point1x, point1y, coordx , coordy);
        point1x=coordx ;
        point1y= coordy;
    }
}

public void ecrisFormuleEllipse()  {
   int la= valEnt(largeurZoneGraphique()/2);
    int ha= valEnt(hauteurZoneGraphique());

    ecrisGraphique( -la+30, ha/2.5, "( x           )");
   ecrisGraphique( -la+100, ha/2.455, "2");

    if (h != 0) {          // ! different de
            if (h > 0) {
            ecrisGraphique(-la+45, ha/2.5,"-" +h);
           }
            else {
            ecrisGraphique ( -la+45, ha/2.5,"+" + -h);
           }

       }
       else {ecrisGraphique(-la+45, ha/2.5,"-" +h);}
    segment(-la+27, ha/2.7, -la+105, ha/2.7);
    ecrisGraphique(-la+35, ha/3.3, "(");
    ecrisGraphique(-la+40, ha/3.3, "" + a);
    ecrisGraphique(-la+90, ha/3.3, ")");
    ecrisGraphique(-la+95, ha/3.1, "2");

    ecrisGraphique( -la+113, ha/2.7, "+");
    ecrisGraphique( -la+125, ha/2.5, "( y           )");
    ecrisGraphique( -la+195, ha/2.455, "2");
    if (k != 0) {
           if (k > 0) {
            ecrisGraphique(-la+140, ha/2.5, "-" + k);
           }
            else {
              ecrisGraphique(-la+140, ha/2.5, "+" + -k);
            }
        }
    else { ecrisGraphique(-la+140, ha/2.5, "-" + k);}
    segment(-la+122, ha/2.7, -la+200, ha/2.7);
    ecrisGraphique(-la+130, ha/3.3, "(");
    ecrisGraphique(-la+135, ha/3.3, "" + b);
    ecrisGraphique(-la+185, ha/3.3, ")");
    ecrisGraphique(-la+190, ha/3.1, "2");
    ecrisGraphique(-la+205, ha/2.8, "= 1");
}

public void DessinerEllipse(){

double rayondisque= valeurGlissiere(1);
DessinerSommetsEllipse();
DessinerFoyersEllipse();
ContourEllipse();
ecrisFormuleEllipse();
}

/******************************************PROCDURES POUR l'HYPERBOLE HORIZONTALE************************************************/

public void placerPointsHyperboleHoriz() {
    centreX = h;
    centreY = k;

    sommetX[0] = h+a;
    sommetY[0] = k;

    sommetX [1] = h+a;
    sommetY [1] = k+b;

    sommetX [2] = h-a;
    sommetY [2] = k+b;

    sommetX [3] = h-a;
    sommetY [3] = k;

    sommetX [4] = h-a;
    sommetY [4] = k-b;

    sommetX [5] = h+a;
    sommetY [5] = k-b;


}
public void DessinerSommetsHyperboleHoriz(){
   double rayondisque= valeurGlissiere(1);
   couleurRemplissage(noir);
   disque(centreX,centreY,rayondisque);
   disque(sommetX[0],sommetY[0],rayondisque);
   disque(sommetX[1],sommetY[1],rayondisque);
   disque(sommetX[2],sommetY[2],rayondisque);
   disque(sommetX[3],sommetY[3],rayondisque);
   disque(sommetX[4],sommetY[4],rayondisque);
   disque(sommetX[5],sommetY[5],rayondisque);
   couleurCrayon(rouge);
   segment ((h-30*a),(k-30*b),(h+30*a),(k+30*b));  // asymptotes
   segment ((h-30*a),(k+30*b),(h+30*a),(k-30*b));   //asymptotes
}

public void DessinerFoyerHyperboleHoriz (){

      double rayondisque= valeurGlissiere(1);

      couleurRemplissage(bleu);

      disque (racine(a*a+b*b)+h, k, rayondisque);
      disque (-racine(a*a+b*b)+h, k, rayondisque);

}

public void ContourHyperboleHoriz(){
    double coordy ;
    double coordy2;
    double point1x= h+abs(a);
    double point1y= k ;
    double point1y2=k;
    int la= valEnt(largeurZoneGraphique()/2);
    int ha= valEnt(hauteurZoneGraphique());

    for (double coordx = (h+abs(a)) ; coordx <= la ; coordx = coordx+1)
{//permet de faire la partie droite de l'hyperbole
        double bcarre= b*b ;
        coordy = 
racine(-1*(bcarre-((coordx-h)*(coordx-h))/(a*a)*(bcarre)))+k;
        coordy2 = 
-1*(racine(-1*(bcarre-((coordx-h)*(coordx-h))/(a*a)*(bcarre))))+k;
        couleurCrayon (noir);
        segment ( point1x, point1y, coordx , coordy);
        couleurCrayon (noir);
        segment (point1x, point1y2, coordx, coordy2);
        point1x=coordx ;
        point1y= coordy;
        point1y2 = coordy2;
    }
      point1x = h-abs(a);   //Rinitialisation des valeurs de point1x et de point1y
      point1y= k;
      point1y2 = k;

        for (double coordx = (h-abs(a)) ; coordx>=-la ; coordx = coordx-1)
{//permet de faire la partie gauche de l'hyperbole
        double bcarre= b*b ;
        coordy = 
racine(-1*(bcarre-((coordx-h)*(coordx-h))/(a*a)*(bcarre)))+k;
        coordy2 =
-1*(racine(-1*(bcarre-((coordx-h)*(coordx-h))/(a*a)*(bcarre))))+k;

        couleurCrayon (noir);
        segment ( point1x, point1y, coordx , coordy);
        couleurCrayon (noir);
        segment (point1x, point1y2, coordx, coordy2);
        point1x=coordx ;
        point1y= coordy;
        point1y2 = coordy2;
    }

}
public void ecrisFormuleHyperboleHoriz(){

    int la= valEnt(largeurZoneGraphique()/2);
    int ha= valEnt(hauteurZoneGraphique());

    ecrisGraphique( -la+30, ha/2.5, "( x            )");
    ecrisGraphique( -la+100, ha/2.455, "2");
    if (h != 0) {          // ! different de
            if (h > 0) {
            ecrisGraphique(-la+45, ha/2.5,"-" +h);
           }
            else {
            ecrisGraphique ( -la+45, ha/2.5,"+" + -h);
           }
       }
      else {ecrisGraphique(-la+45, ha/2.5,"-" +h);}
    segment(-la+27, ha/2.7, -la+105, ha/2.7);
    ecrisGraphique(-la+35, ha/3.3, "(");
    ecrisGraphique(-la+40, ha/3.3, "" + a);
    ecrisGraphique(-la+90, ha/3.3, ")");
    ecrisGraphique(-la+95, ha/3.1, "2");

    ecrisGraphique( -la+113, ha/2.7, "-");
    ecrisGraphique( -la+125, ha/2.5, "( y            )");
    ecrisGraphique( -la+195, ha/2.455, "2");

    if (k != 0) {
           if (k >0) {
            ecrisGraphique(-la+140, ha/2.5, "-" + k);
           }
            else {
              ecrisGraphique(-la+140, ha/2.5, "+" + -k);
            }
        }
    else {ecrisGraphique(-la+140, ha/2.5, "-" + k);}
    segment(-la+122, ha/2.7, -la+200, ha/2.7);
    ecrisGraphique(-la+130, ha/3.3, "(");
    ecrisGraphique(-la+135, ha/3.3, "" + b);
    ecrisGraphique(-la+185, ha/3.3, ")");
    ecrisGraphique(-la+190, ha/3.1, "2");
    ecrisGraphique(-la+205, ha/2.8, "= 1");


}

public void DessinerHyperboleHoriz(){
double rayondisque= valeurGlissiere(1);

DessinerSommetsHyperboleHoriz();
ContourHyperboleHoriz();
ecrisFormuleHyperboleHoriz();
DessinerFoyerHyperboleHoriz();

}

/**********************************************PROCDURES POUR L'HYPERBOLE VERTICALE*******************************************/

public void placerPointsHyperboleVert() {
    centreX = h;
    centreY = k;

    sommetX[0] = h+a;
    sommetY[0] = k+b;

    sommetX [1] = h;
    sommetY [1] = k+b;

    sommetX [2] = h-a;
    sommetY [2] = k+b;

    sommetX [3] = h-a;
    sommetY [3] = k-b;

    sommetX [4] = h;
    sommetY [4] = k-b;

    sommetX [5] = h+a;
    sommetY [5] = k-b;
}

public void DessinerSommetsHyperboleVert(){
double rayondisque= valeurGlissiere(1);
couleurRemplissage(noir);

   disque(centreX,centreY,rayondisque);
   disque(sommetX[0],sommetY[0],rayondisque);
   disque(sommetX[1],sommetY[1],rayondisque);
   disque(sommetX[2],sommetY[2],rayondisque);
   disque(sommetX[3],sommetY[3],rayondisque);
   disque(sommetX[4],sommetY[4],rayondisque);
   disque(sommetX[5],sommetY[5],rayondisque);
   couleurCrayon(rouge);
   segment ((h-30*a),(k-30*b),(h+30*a),(k+30*b));  // asymptotes
   segment ((h-30*a),(k+30*b),(h+30*a),(k-30*b));   //asymptotes
}

public void DessinerFoyerHyperboleVert (){

    double rayondisque= valeurGlissiere(1);

    couleurRemplissage(bleu);
    disque (h,racine(a*a+b*b)+k, rayondisque);
    disque (h,-racine(a*a+b*b)+k, rayondisque);

}

public void ContourHyperboleVert(){
    double coordy ;
    double coordy2;
    double point1x= h+a;
    double point1y= k ;
    double point1y2=k;
    int la= valEnt(largeurZoneGraphique()/2);
    int ha= valEnt(hauteurZoneGraphique());
    point1x=-la;
    point1y=racine(b*b+((-la-h)*(-la-h))/(a*a)*(b*b))+k;
    point1y2=-1*(racine(b*b+((-la-h)*(-la-h))/(a*a)*(b*b)))+k;

    for (double coordx = -la ; coordx <= la ; coordx = coordx+1) {//permet de faire la partie droite de l'hyperbole
        double bcarre= b*b ;
        coordy = racine(bcarre+((coordx-h)*(coordx-h))/(a*a)*(bcarre))+k;
        coordy2 = 
-1*(racine(bcarre+((coordx-h)*(coordx-h))/(a*a)*(bcarre)))+k;
       // disque(coordx,coordy, 1);
        couleurCrayon (noir);
        segment ( point1x, point1y, coordx , coordy);
        couleurCrayon (noir);
        segment (point1x, point1y2, coordx, coordy2);
        point1x=coordx ;
        point1y= coordy;
        point1y2 = coordy2;
    }
}

 public void ecrisFormuleHyperboleVert(){

    int la= valEnt(largeurZoneGraphique()/2);
    int ha= valEnt(hauteurZoneGraphique());


        ecrisGraphique( -la+30, ha/2.5, "( y            )");
        ecrisGraphique( -la+100, ha/2.455, "2");
        if (k != 0) {          // ! different de
            if (k > 0) {
                ecrisGraphique(-la+45, ha/2.5,"-" +k);
            }
            else {
                ecrisGraphique ( -la+45, ha/2.5,"+" + -k);
            }
       }
       else {ecrisGraphique(-la+45, ha/2.5,"-" +k);}

    segment(-la+27, ha/2.7, -la+105, ha/2.7);
    ecrisGraphique(-la+35, ha/3.3, "(");
    ecrisGraphique(-la+40, ha/3.3, "" + b);
    ecrisGraphique(-la+90, ha/3.3, ")");
    ecrisGraphique(-la+95, ha/3.1, "2");

    ecrisGraphique( -la+113, ha/2.7, "-");
    ecrisGraphique( -la+125, ha/2.5, "( x            )");
    ecrisGraphique( -la+195, ha/2.455, "2");
        if (h != 0) {
           if (h > 0) {
            ecrisGraphique(-la+140, ha/2.5, "-" + h);
           }
            else {
              ecrisGraphique(-la+140, ha/2.5, "+" + -h);
            }
        }
       else {ecrisGraphique(-la+140, ha/2.5, "-" + h);}
    segment(-la+122, ha/2.7, -la+200, ha/2.7);
    ecrisGraphique(-la+130, ha/3.3, "(");
    ecrisGraphique(-la+135, ha/3.3, "" + a);
    ecrisGraphique(-la+185, ha/3.3, ")");
    ecrisGraphique(-la+190, ha/3.1, "2");
    ecrisGraphique(-la+205, ha/2.8, "= 1");
    }
    
public void DessinerHyperboleVert(){

double rayondisque = valeurGlissiere(1);

DessinerSommetsHyperboleVert();
ContourHyperboleVert();
ecrisFormuleHyperboleVert();
DessinerFoyerHyperboleVert();
}

/***********************************************PROCDURES POUR LA PARABOLE HORIZONTALE******************************************/

public void placerPointsParaboleHoriz() {
    centreX = h;
    centreY = k;
    
    sommetX[0] = h+(0.25/b*100);
    sommetY[0] = k;
     
    
}
public void DessinerSommetsParaboleHoriz(){
    double rayondisque= valeurGlissiere(1);
    couleurRemplissage(noir);
    disque(centreX,centreY,rayondisque);
    couleurRemplissage(noir);
    disque(sommetX[0],sommetY[0],rayondisque);
    couleurCrayon(rouge);
    segment(h-(0.25/b*100),-500,h-(0.25/b*100),500);
    
}
public void DessinerContourParaboleHoriz(){

    double coordx;
    double point1x= h;
    double point1y= k ;
    int la= valEnt(largeurZoneGraphique());
    int ha= valEnt(hauteurZoneGraphique());
    point1y=-ha;
    point1x= b*((-ha-k)*(-ha-k))+h*200;


    for (double coordy = -ha ; coordy <= ha ; coordy = coordy+1) {

        coordx = b*((coordy-k)*(coordy-k))+h*200;
        couleurCrayon (noir);
        segment ( point1x/200, point1y, coordx/200 , coordy);
        point1x=coordx ;
        point1y= coordy;
        }
    }
 
public void ecrisFormuleParaboleHoriz(){

    int la= valEnt(largeurZoneGraphique()/2);
    int ha= valEnt(hauteurZoneGraphique());
    double b1=arrondis(b*1000);
    double b2=b1/1000;

    ecrisGraphique( -la+10, ha/2.5, "x = " );
    ecrisGraphique( -la+40, ha/2.5, "" +b2);

    ecrisGraphique( -la+88, ha/2.5, "(y"   );
    if (k != 0) {          // ! different de
            if (k > 0) {
            ecrisGraphique(-la+100, ha/2.5,"-" +k);
           }
            else {
            ecrisGraphique ( -la+100, ha/2.5,"+" + -k);
           }

       }
     else {ecrisGraphique(-la+100, ha/2.5,"-" +k);}
    ecrisGraphique(-la+150, ha/2.5, ")");
    ecrisGraphique(-la+160, ha/2.35, "2");
    if (h != 0) {
           if (h > 0) {
            ecrisGraphique(-la+170, ha/2.5, "+" + h);
           }
            else {
              ecrisGraphique(-la+170, ha/2.5, "-" + -h);
            }

        }
     else {ecrisGraphique(-la+170, ha/2.5,"+" + h);}
}

public void DessinerParaboleHoriz(){
      DessinerSommetsParaboleHoriz();
      DessinerContourParaboleHoriz();
      ecrisFormuleParaboleHoriz();
    }

/**********************************************PROCDURES POUR LA PARABOLE VERTICALE******************************************/

public void placerPointsParaboleVert() {
    centreX = h;
    centreY = k;

    sommetX[0] = h ;
    sommetY[0] = k+(0.25/a*100);
}


public void DessinerSommetsParaboleVert(){
   double rayondisque= valeurGlissiere(1);
    couleurRemplissage(noir);
    disque(centreX,centreY,rayondisque);
    couleurRemplissage(noir);
    disque(sommetX[0],sommetY[0],rayondisque);
    couleurCrayon(rouge);
    segment(-500,k-(0.25/a*100),500,k-(0.25/a*100));
 
}


public void DessinerContourParaboleVert(){

    double rayondisque= valeurGlissiere(1);
    double coordy ;
    double point1x= h;
    double point1y= k ;
    int la= valEnt(largeurZoneGraphique()/2);
    int ha= valEnt(hauteurZoneGraphique());
    point1x=-la;
    point1y= a*((-la-h)*(-la-h))+k*200;

    for (double coordx = -la ; coordx <= la ; coordx = coordx+1) {

        coordy = a*((coordx-h)*(coordx-h))+k*200; // l'chelle de k doit ?tre ajuste aussi
        couleurCrayon (noir);
        segment ( point1x, point1y/200, coordx , coordy/200);
        point1x=coordx ;
        point1y= coordy;
     }

    }
   
public void ecrisFormuleParaboleVert()  {

    int la= valEnt(largeurZoneGraphique()/2);
    int ha= valEnt(hauteurZoneGraphique());
    double a1=arrondis(a*1000);
    double a2=a1/1000;

    ecrisGraphique( -la+10, ha/2.5, "y = " );
    ecrisGraphique( -la+40, ha/2.5, ""+a2 );

    ecrisGraphique( -la+88, ha/2.5, "(x"   );
    if (h != 0) {          // ! different de
            if (h > 0) {
            ecrisGraphique(-la+100, ha/2.5,"-" +h);
           }
            else {
            ecrisGraphique ( -la+100, ha/2.5,"+" + -h);
           }

       }
     else {ecrisGraphique(-la+100, ha/2.5,"-" +h);}
    ecrisGraphique(-la+150, ha/2.5, ")");
    ecrisGraphique(-la+160, ha/2.35, "2");
    if (k != 0) {
           if (k > 0) {
            ecrisGraphique(-la+170, ha/2.5, "+" + k);
           }
            else {
              ecrisGraphique(-la+170, ha/2.5, "-" + -k);
            }

        }
     else {ecrisGraphique(-la+170, ha/2.5,"+" + k);}
}

public void DessinerParaboleVert(){
    DessinerSommetsParaboleVert();
    DessinerContourParaboleVert();
    ecrisFormuleParaboleVert();

}

/*********************************************PROCDURES COMMUNES*******************************************/
public void DessinerAxesDuPlan(){
    couleurCrayon (noir);
    int la= valEnt(largeurZoneGraphique()/2);

    segment(-la,0,la-20,0); //Tracer Axe des X
    segment(la-20,0,la-30,-10);//bout de fl?che
    segment(la-20,0,la-30,10);//bout de la fleche

    int ha= valEnt(hauteurZoneGraphique());
    segment(0,-ha,0,ha/2.5+10);  // Tracer Axe des Y
    segment(0,ha/2.5+10,-10,ha/2.5);
    segment(0,ha/2.5+10,10,ha/2.5);
}
public void LesAuteures(){ 
   message( "Les auteures de ce projet sont Catherine Painchaud et Genevi?ve Tremblay et a t labor durant la session hiver 2006"); 
}

/****************************Les actions des boutons************************************/

public void actionBouton1(){
}

public void actionBouton2(){
 
}

public void actionBouton3(){

}
public void actionBouton4(){
  
}

public void actionBouton5(){
 
}

public void actionBouton6(){

}

/**************  Les actions des menus  ****************************/

public void actionMenu1Item1() {

   ConiqueChoisie=0;
    h=0;
    k=0;
    a=100;
    b=50;
    placerPointsEllipse();
    DessinerConiques();
}

public void actionMenu1Item2(){
    ConiqueChoisie=1;
     h=0;
     k=0;
     a=100;
     b=50;
     placerPointsHyperboleHoriz();
     DessinerConiques();
}

public void actionMenu1Item3(){
   ConiqueChoisie=2;
   h=0;
   k=0;
   a=50;
   b=100;
   placerPointsHyperboleVert();
   DessinerConiques();
   }
 
public void actionMenu1Item4(){
  ConiqueChoisie=3;
   h=0;
   k=0;
   b=1.5;
   placerPointsParaboleHoriz();
   DessinerConiques();  
  }
public void actionMenu1Item5(){
  ConiqueChoisie=4;
   h = 0;
   k = 0;
   a = 1.5;
   placerPointsParaboleVert();
   DessinerConiques();
}

public void actionMenu2Item1() {
       quitter();
}
public void actionMenu2Item2(){
}
public void actionMenu3Item1(){
       LesAuteures();
}
public void actionMenu3Item2(){
 
}
public void actionMenu4Item1(){

}
/*************** Les actions des glissieres *********************************/
public void actionGlissiere1(double d) {
   DessinerConiques();
}


/**************** Les actions de la souris *******************************/

    public void clicSouris(double x, double y){
    }

    public void debutGlisser(double x, double y){
        trouverPoint(x,y,valeurGlissiere(1));
        deplacerPoint(x,y);
        DessinerConiques();
    }

    public void deplacerPoint(double x, double y){
        if (ConiqueChoisie == 0){
            deplacerPointEllipse(x,y);
        }
        if (ConiqueChoisie == 1){
            deplacerPointHyperboleHoriz(x,y);
        }
        if (ConiqueChoisie == 2){
            deplacerPointHyperboleVert(x,y);
        }
        if (ConiqueChoisie == 3){
            deplacerPointParaboleHoriz(x,y);
        }
        if (ConiqueChoisie == 4){
            deplacerPointParaboleVert(x,y);
        }

    }

    public void finGlisser(double x, double y){
        deplacerPoint (x,y);
        DessinerConiques();
        pointDeplace =0;
    }

    public void glisserEnCours(double x, double y){
        if (pointDeplace==0){
            return;
        }
        deplacerPoint(x,y);
        DessinerConiques();
    }

    public void trouverPoint(double x, double y, double r){
           if (distCarre(centreX,centreY,x,y) <=r*r)  {
               pointDeplace =1;
               return;
            }
           if (distCarre(sommetX[0],sommetY[0],x,y) <=r*r)  {
               pointDeplace =2;
                return;
            }
           if (distCarre(sommetX[1],sommetY[1],x,y) <=r*r)  {
               pointDeplace =3;
                return;
            }
           if (distCarre(sommetX[2],sommetY[2],x,y) <=r*r)  {
               pointDeplace =4;
                return;
            }
           if (distCarre(sommetX[3],sommetY[3],x,y) <=r*r)  {
               pointDeplace =5;
                return;
            }
           if (distCarre(sommetX[4],sommetY[4],x,y) <=r*r)  {
               pointDeplace =6;
                return;
            }
           if (distCarre(sommetX[5],sommetY[5],x,y) <=r*r)  {
               pointDeplace =7;
                return;
            }
   }

     public void deplacerPointEllipse ( double x, double y) {
         

      
         
           
           if (pointDeplace==1) {
              if (y<=-285){h=x; k=-285;} 
              if (y>-285&&y<285){
                   h=x; k=y;}
              if (y>=285){h=x;k=285;} 
              
            }
           if (pointDeplace==2) {
               a = x - h;
           }
           if (pointDeplace == 3){
               b = y - k;
           }
           if (pointDeplace == 4){
               a = -x + h;
           }
           if (pointDeplace == 5){
               b = -y + k;
           }
          placerPointsEllipse();
    }

        public void deplacerPointHyperboleHoriz ( double x, double y) {
           if (pointDeplace==1) {
              if (y<=-285){h=x; k=-285;} 
              if (y>-285&&y<285){
                   h=x; k=y;}
              if (y>=285){h=x;k=285;} 
           }
           if (pointDeplace==2) {
               a = x - h;
           }
           if (pointDeplace == 3){
               b = y - k;
           }
           if (pointDeplace == 4){
               b= y - k ;
           }
           if (pointDeplace == 5){
               a = -x + h;
           }
            if (pointDeplace == 6){
               b = -y + k;
           }
            if (pointDeplace == 7){
               b = -y + k;
           }
          placerPointsHyperboleHoriz();
    }

       public void deplacerPointHyperboleVert ( double x, double y) {
           if (pointDeplace==1) {
              if (y<=-285){h=x; k=-285;} 
              if (y>-285&&y<285){
                   h=x; k=y;}
              if (y>=285){h=x;k=285;} 
           }
           if (pointDeplace==2) {
               a = x - h;
           }
           if (pointDeplace == 3){
               b = y - k;
           }
           if (pointDeplace == 4){
               a = -x + h ;
           }
           if (pointDeplace == 5){
               a = -x + h;
           }
            if (pointDeplace == 6){
               b = -y + k;
           }
            if (pointDeplace == 7){
               a = x - h;
           }
          placerPointsHyperboleVert();
    }
    public void deplacerPointParaboleHoriz ( double x, double y) {
           if (pointDeplace==1) {
              if (y<=-285){h=x; k=-285;} 
              if (y>-285&&y<285){
                   h=x; k=y;}
              if (y>=285){h=x;k=285;} 
           }
           if (pointDeplace==2) {
              b = 0.25/((x-h)/100);
           }
          placerPointsParaboleHoriz();
    }
    public void deplacerPointParaboleVert ( double x, double y) {
           if (pointDeplace==1) {
              if (y<=-285){h=x; k=-285;} 
              if (y>-285&&y<285){
                   h=x; k=y;}
              if (y>=285){h=x;k=285;} 
           }
           if (pointDeplace==2) {
              a = 0.25/((y-k)/100);
           }
          placerPointsParaboleVert();
    }
   public double distCarre ( double u, double v, double x, double y){
      return (u-x)*(u-x) + (v-y)*(v-y);
    }

    public void actionTailleChange() {
      centreTortue();
      videGraphique();
      ecrisFormuleEllipse();
      videGraphique();
      ecrisFormuleHyperboleHoriz();
      videGraphique();
      ecrisFormuleHyperboleVert();
      videGraphique();
      ecrisFormuleParaboleVert();
      videGraphique();
      ecrisFormuleParaboleHoriz();
      DessinerConiques();
    }
/***************************************************************************
*
*                  NE PAS MODIFIER CETTE SECTION
*
**************************************************************************/

    public static String[][] Menus = {s_nomsMenus1, c_nomsMenus2, c_nomsMenus3,
nomsMenus4, nomsMenus5, nomsMenus6, nomsMenus7, nomsMenus8};

    public Expresso(int l, int h, String titre, String[] nomsBoutons1, 
String[]
nomsBoutons2, String[][] Menus, boolean avecTexte){
        super(l, h, titre, nomsBoutons1, nomsBoutons2, Menus, avecTexte);
    }

    public Expresso() {
        this(baseFenetre, hauteurFenetre, titreFenetre, nomsBoutonsLigne1,nomsBoutonsLigne2, Menus, zoneTexte);
    }

    public static void executer(boolean applet){
        initGlissieres();
        ajoutDeGlissieres();
        Expresso maFenetre = new Expresso();
        faireApplet(applet);
        maFenetre.toFront();
        maFenetre.initialisation();
    }

    public static void main(String[] args){
        executer(false);
    }

}

